]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- unified tabs
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
d54662bf
AF
1# PLD rpm macros
2
f633038a 3# other macros
e05017c1 4%epoch 0
f633038a
AM
5%_enable_debug_packages 1
6
8f74418b
MM
7%__id @__ID@
8%__id_u %{__id} -u
9%__chown_Rhf @__CHOWN_RHF@
10%__chgrp_Rhf @__CHGRP_RHF@
11
07163ba3 12%_fixowner [ `%{__id_u}` = '0' ] && %{__chown_Rhf} root:@ROOT_GROUP@
d54662bf 13%_fixgroup true
16cb1d91 14%_fixperms %{__chmod} -Rf @FIXPERMS@
d54662bf 15%_topdir %(echo $HOME)/rpm
9c404149
AM
16#-----------------------------------------------------------------
17# CFLAGS and LDFLAGS used to build
18
7bec8f51 19%debuginfocflags %{expand:%%define __dic_%{?_enable_debug_packages} 1}%{?__dic_1: -ggdb}%{expand:%%undefine __dic_%{?_enable_debug_packages}}
f633038a 20
8f74418b 21%debugcflags -O0 -g -Wall
82656cfe 22%rpmcflags %{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}
8a9c8197
PS
23%rpmcxxflags %{rpmcflags}
24# -fvisibility-inlines-hidden disabled. see gcc/PR(19664,20218) for details.
25# %rpmcxxflags %{rpmcflags} -fvisibility-inlines-hidden
26%rpmldflags %{nil}
d23d3883 27# %rpmldflags -Wl,--as-needed
9c404149 28
ba1fdedc 29# kernel compiler
d2e1bc22 30%kgcc gcc
31%kgcc_package gcc
ba1fdedc 32
33040789 33# Build system path macros.
34#
bddadece
JB
35%__autoconf autoconf %{?debug:-Wall}
36%__automake automake -a -c -f --foreign
f93109a0 37%__autopoint autopoint --force
38
83094b62 39%__gettextize { \
afff6d37 40 if ! gettextize --version | grep -q '0\.10\.' ; then \
8a995cff
JB
41 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
42 gettextize --copy --force --no-changelog; \
97589b6e 43 else \
8a995cff
JB
44 gettextize --copy --force --no-changelog --intl; \
45 fi; \
46 if [ ! -f po/Makevars ]; then \
47 cp -f po/Makevars{.template,}; \
48 fi; \
49 else \
50 gettextize --copy --force; \
83094b62 51 fi; \
8a995cff 52}
f93109a0 53
54%__glib_gettextize glib-gettextize --copy --force
55%__gnome_doc_common gnome-doc-common --copy
56%__gtkdocize gtkdocize --copy
57%__intltoolize intltoolize --copy --force
58%__libtoolize libtoolize --copy --force
33040789 59
6a5eda77 60%dependencytracking %{nil}
9c404149 61#-----------------------------------------------------------------
9f4ce098 62%configure2_13 { \
9c404149
AM
63 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
64 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
65 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 66 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 67 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
8ec1a12b 68 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
8983c4c4
AM
69 %{?__cc:CC="%{__cc}" ; export CC ; } \
70 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 71 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 72 --host=%{_target_platform} \
9c404149
AM
73 --prefix=%{_prefix} \
74 --exec-prefix=%{_exec_prefix} \
75 --bindir=%{_bindir} \
76 --sbindir=%{_sbindir} \
77 --sysconfdir=%{_sysconfdir} \
78 --datadir=%{_datadir} \
79 --includedir=%{_includedir} \
80 --libdir=%{_libdir} \
81 --libexecdir=%{_libexecdir} \
82 --localstatedir=%{_localstatedir} \
83 --sharedstatedir=%{_sharedstatedir} \
84 --mandir=%{_mandir} \
85 --infodir=%{_infodir} \
c0d1b3ad 86 --x-libraries=/usr/X11R6/%{_lib} \
93059874 87 %{dependencytracking} \
9c404149
AM
88}
89
4a6b0d54 90#----------------------------------------------------------------
57f4166d 91%configure {./configure \
4a6b0d54
AF
92 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
93 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 94 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 95 FFLAGS="${FFLAGS:-%rpmcflags}" \
a2bd5992 96 CPPFLAGS="${CPPFLAGS:-}" \
8983c4c4
AM
97 %{?__cc:CC="%{__cc}"} \
98 %{?__cxx:CXX="%{__cxx}"} \
4a6b0d54
AF
99 --build=%{_target_platform} \
100 --prefix=%{_prefix} \
101 --exec-prefix=%{_exec_prefix} \
102 --bindir=%{_bindir} \
103 --sbindir=%{_sbindir} \
104 --sysconfdir=%{_sysconfdir} \
105 --datadir=%{_datadir} \
106 --includedir=%{_includedir} \
107 --libdir=%{_libdir} \
108 --libexecdir=%{_libexecdir} \
109 --localstatedir=%{_localstatedir} \
110 --sharedstatedir=%{_sharedstatedir} \
111 --mandir=%{_mandir} \
112 --infodir=%{_infodir} \
c0d1b3ad 113 --x-libraries=/usr/X11R6/%{_lib} \
93059874 114 %{dependencytracking} \
4a6b0d54
AF
115}
116
7dbab518 117# ------------------------------------------------------------------------
c80506a3
AM
118# Overloading of some basic macros
119%prep \
120%%prep\
121LANG=C\
122export LANG\
14e77e64 123unset DISPLAY ||:\
6db5639d 124unset LINGUAS ||:\
c80506a3
AM
125%{nil}
126
127%build %%build\
128LANG=C\
129export LANG\
14e77e64 130unset DISPLAY ||:\
6db5639d 131unset LINGUAS ||:\
c80506a3
AM
132%{nil}
133
134%install %{?_enable_debug_packages:%{?buildsubdir:%{debug_package}}}\
135%%install\
136LANG=C\
137export LANG\
14e77e64 138unset DISPLAY ||:\
6db5639d 139unset LINGUAS ||:\
c80506a3
AM
140%{nil}
141
142# ------------------------------------------------------------------------
7dbab518
MM
143# Conditional build stuff.
144
145# Check if symbol is defined.
146# Example usage: %if %{defined with_foo} && %{undefined with_bar} ...
147%defined() %{expand:%%{?%{1}:1}%%{!?%{1}:0}}
148%undefined() %{expand:%%{?%{1}:0}%%{!?%{1}:1}}
149
566fa098
MM
150# Shorthand for %{defined with_...}
151%with() %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
152%without() %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
153
7dbab518
MM
154# Handle conditional builds. %bcond_with is for case when feature is
155# default off and needs to be activated with --with ... command line
156# switch. %bcond_without is for the dual case.
157#
158# %bcond_with foo defines symbol with_foo if --with foo was specified on
159# command line.
160# %bcond_without foo defines symbol with_foo if --without foo was *not*
161# specified on command line.
162#
163# For example:
164#
165# %bcond_with extra_fonts
166# %bcond_without static
f52f9976 167# %if %{with extra_fonts}
7dbab518
MM
168# ...
169# %endif
f52f9976 170# %ifdef %{with static}
7dbab518
MM
171# ...
172# %endif
173# %{?with_static: ... }
174# %{!?with_static: ... }
175# %{?with_extra_fonts: ... }
176# %{!?with_extra_fonts: ... }
177#
178# The bottom line: never use without_foo, _with_foo nor _without_foo, only
179# with_foo. This way changing default set of bconds for given spec is just
180# a matter of changing single line in it and syntax is more readable.
181%bcond_with() %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
182%bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}
183# ------------------------------------------------------------------------
184
9c404149
AM
185# Location of autoconf macros
186%_aclocaldir %(aclocal --print-ac-dir)
187
e2804f99
AM
188# Location of omf files
189%_omf_dest_dir %(scrollkeeper-config --omfdir)
190
e987a186 191# Location of pkgconfig files
9a4e877a 192%_pkgconfigdir /usr/%{_lib}/pkgconfig
e987a186 193
486b0b5f 194# Location of desktop files
195%_desktopdir /usr/share/applications
86dff2d0 196%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 197
481463e9 198# Location of pixmaps for applnk/desktop files
e1f0a822 199%_pixmapsdir /usr/share/pixmaps
9c404149 200
481463e9 201# Location of themable icons for applnk/desktop files
b36c8e2a 202%_iconsdir /usr/share/icons
203
e987a186
JB
204# Location of fonts directories
205%_fontsdir /usr/share/fonts
206
b3282f3f 207# Location of Gtk and associated libraries documentation
6eed6d84 208%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 209
fc4d7771 210# Location of KDE documentation
211%_kdedocdir %{_defaultdocdir}/kde/HTML
212
5869828c 213# unsermake script
214%__unsermake /usr/share/unsermake/unsermake
215
9c404149
AM
216# Current date
217%date %(LC_ALL="C" date +"%a %b %d %Y")
218
219# tmp directory
220%tmpdir %(echo "${TMPDIR:-/tmp}")
221
222# Example files, programs, scripts...
223%_examplesdir /usr/src/examples
224
8377d27d 225# The directory holding Linux kernel sources
226%_kernelsrcdir /usr/src/linux
227
9c404149 228# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 229%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 230
8f74418b 231# Requires name = version-release
16cb1d91 232%requires_releq() %(LC_ALL="C" echo '%*' | xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
8bf3719d 233
16cb1d91
JB
234%releq_kernel_up() %(LC_ALL="C" rpm -qf --qf 'kernel-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | grep -vE "(is not|no such)")
235%releq_kernel_smp() %(LC_ALL="C" rpm -qf --qf 'kernel-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | grep -vE "(is not|no such)")
236%requires_releq_kernel_up() %(LC_ALL="C" rpm -qf --qf 'PreReq: kernel-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | grep -vE "(is not|no such)")
237%requires_releq_kernel_smp() %(LC_ALL="C" rpm -qf --qf 'PreReq: kernel-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | grep -vE "(is not|no such)")
8bf3719d 238
16cb1d91 239%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
01a9f990 240
179fcc7f 241%apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
b9d5d440 242
243# kernel version-release handling
541d11fe 244%__kernel_ver %([ -f %{_kernelsrcdir}/include/linux/version.h ] && (grep UTS_RELEASE %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
8fecb226 245%__kernel_rel %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h --queryformat "%{RELEASE}" | grep -v "is not")
16cb1d91
JB
246%__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h --queryformat "%{VERSION}-%{RELEASE}" | grep -v "is not")
247%_kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
f62e856d 248%_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
87be1cf0 249
e00dd7f6 250# sgml macros
741b471b 251%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
252%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
847db862 253%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
741b471b 254%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
255%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
256%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 257%docbook_sgmlcat_fix() { for l in \
258'' \
259' -- default decl --' \
260'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
261' -- hacks for opensp --' \
262'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
263'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
264'' \
265; do echo $l; done >> %1 \
266}
267
9c404149
AM
268#-----------------------------------------------------------------
269# find and gzip all files in %{_mandir} and %{infodir}
270#
271# Requires: xargs, find
272#
273#%no_install_post_compress_docs 1
274%__spec_install_post_compress_docs { \
9c404149 275%{!?no_install_post_compress_docs: \
822d4d81 276 echo "Compress man and info pages."; \
9c404149
AM
277 %{?verbose:set -x;} \
278 for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
279 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
280 find "$RPM_BUILD_ROOT$i" -name \*.bz2 -print | xargs -r %{__bzip2} -df; \
281 find "$RPM_BUILD_ROOT$i" -name \*.gz -print | xargs -r %{__gzip} -dnf; \
282 find "$RPM_BUILD_ROOT$i" -type f -print | xargs -r %{__gzip} -9nf; \
283 fi; \
284 done; \
285} }
286
287#-----------------------------------------------------------------
288# Strip executable binaries and shared object files
289#
290# Requires: find, awk, strip, cut, xargs
291#
292#%no_install_post_strip 1
293%__spec_install_post_strip {%{!?debug: \
294%{!?no_install_post_strip: \
9f0d4f36
JB
295 %{?verbose:set -x;} \
296 if [ -d "$RPM_BUILD_ROOT" ]; then \
8f74418b 297 echo "Strip executable binaries, archives and shared object files."; \
60ad88f2 298 filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
9c404149
AM
299 elfexelist=`echo $filelist | xargs -r file | \
300 awk '/ELF.*executable/ {print $1}' | cut -d: -f1`; \
301 elfsharedlist=`echo $filelist | xargs -r file | \
302 awk '/LF.*shared object/ {print $1}' | cut -d: -f1`; \
8f74418b
MM
303 elfarchiveslist=`echo $filelist | xargs -r file | \
304 awk '/current ar archive/ {print $1}' | cut -d: -f1`; \
9c404149 305 if [ -n "$elfexelist" ]; then \
60ad88f2 306 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
9c404149
AM
307 fi; \
308 if [ -n "$elfsharedlist" ]; then \
60ad88f2 309 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
8f74418b
MM
310 fi; \
311 if [ -n "$elfarchiveslist" ]; then \
60ad88f2 312 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $elfarchiveslist; \
9f0d4f36
JB
313 fi; \
314 fi; } \
9c404149 315} }
fc5d7e20 316#-----------------------------------------------------------------
317# remove all RPATH from executable binaries and shared object files
318#
319# Requires: find, awk, cut, xargs, chrpath, uname
320#
321#%no_install_post_chrpath 1
322%__spec_install_post_chrpath {%{!?debug: \
323%{!?no_install_post_chrpath: \
324 %{?verbose:set -x;} \
9f0d4f36 325if [ -d "$RPM_BUILD_ROOT" ]; then \
fc5d7e20 326echo "Remove RPATH from executable binaries and shared object files."; \
adb39da4 327find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"} | xargs -r file | \
5bed2bb7 328 awk '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}' | cut -d: -f1 | \
fc5d7e20 329while read file ; do \
330 rpath= ; \
331 chmod u+w "$file"; \
332 for dir in `chrpath -l "$file" | \
333 awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
334 case $dir in \
494e368c 335 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
fc5d7e20 336 echo "remove-rpath: $dir in $file"; \
337 ;; \
338 * ) \
339 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
340 else rpath="$rpath:$dir" ; fi ; \
341 ;; \
342 esac ; \
343 done ; \
344 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
345 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
9f0d4f36
JB
346done; \
347fi; } \
fc5d7e20 348} }
d72c185f 349#-----------------------------------------------------------------
ccb8ae8d 350# Find and gzip all kernel modules
351#
352# Requires: find
353#
354#%no_install_post_compress_modules 1
355%__spec_install_post_compress_modules { \
ccb8ae8d 356%{!?no_install_post_compress_modules: \
357 %{?verbose:set -x;} \
9f0d4f36
JB
358 if [ -d "$RPM_BUILD_ROOT" ]; then \
359echo "Compress kernel modules if any."; \
d618340e 360 if test -d $RPM_BUILD_ROOT/lib/modules ; then \
16cb1d91
JB
361 find $RPM_BUILD_ROOT/lib/modules -name \*o -type f -print | \
362 xargs -r %{__gzip} -9nf; \
a33b1418 363 find $RPM_BUILD_ROOT/lib/modules -name \*o -type l -printf "%p %l\n" | \
03b234a5 364 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
d618340e 365 fi; \
9f0d4f36 366 fi; \
ccb8ae8d 367} }
9c404149
AM
368
369%_source_payload w9.gzdio
370%_binary_payload w9.bzdio
371
83094b62 372#-----------------------------------------------------------------
0e4cb4dd 373# Update GConf2 schemas
83094b62 374#
375# Requires: GConf2
376#
46885239 377%gconf_schema_install() \
378 umask 022; \
f93109a0 379 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
46885239 380 %{nil}
381
382%gconf_schema_uninstall() \
f93109a0 383if [ $1 = 0 ]; then \
46885239 384 umask 022; \
f93109a0 385 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
386fi \
387%{nil}
388
389#-----------------------------------------------------------------
390# Update desktop MIME database
391# requries: desktop-file-utils
392#
4565b525 393%update_desktop_database_post() {{\
f93109a0 394 umask 022; \
395 /usr/bin/update-desktop-database; \
4565b525 396}}
f93109a0 397
4565b525 398%update_desktop_database_postun() {{\
f93109a0 399if [ $1 = 0 ]; then \
400 umask 022; \
401 /usr/bin/update-desktop-database; \
402fi \
4565b525 403}}
f93109a0 404
405#-----------------------------------------------------------------
406# Update scrollkeeper database
407# requires: scrollkeeper
408#
409%scrollkeeper_update_post() \
f93109a0 410 /usr/bin/scrollkeeper-update -q; \
411 %{nil}
412
413%scrollkeeper_update_postun() \
414if [ $1 = 0 ]; then \
f93109a0 415 /usr/bin/scrollkeeper-update -q; \
416fi \
417%{nil}
418
419#-----------------------------------------------------------------
420# Run ldconfig after installing/deinstalling libraries
421#
422%ldconfig_post() \
423 /sbin/ldconfig; \
424 %{nil}
425
426%ldconfig_postun() \
f93109a0 427 /sbin/ldconfig; \
b430f866 428 %{nil}
83094b62 429
9c404149
AM
430#-----------------------------------------------------------------
431# post %install sequence:
432# - autodeps exceptions
433# - compress all man and info pages,
434# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 435# - compress kernel modules if any
9c404149
AM
436
437###################################################################
438# Requires/Provides automation
439# exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
338726a6 440#
2892b5df
JB
441%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
442%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
443%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
444%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
445%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
338726a6
JB
446#%_noautocompressdoc %{nil}
447#
8f74418b
MM
448%_missing_doc_files_terminate_build 1%{nil}
449%_unpackaged_files_terminate_build %{nil}
8781dc74 450# (X)emacs support
d77dcb61 451%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
8781dc74
AF
452%_emacs_lispdir %(emacs %___emacs_lispdir_helper)
453%_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
25043cd4 454
02b58f60
JK
455%__php_provides %{nil}
456%__php_requires %{nil}
457%__perl_provides %{nil}
458%__perl_requires %{nil}
25043cd4
AF
459
460# Perl specific macro definitions.
c853f847
AF
461%perl_privlib %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
462%perl_archlib %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
463%perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
464%perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
465%perl_sitelib %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
466%perl_sitearch %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
25043cd4 467
c853f847 468%php_pear_dir %{_datadir}/pear
25043cd4
AF
469
470# Python specific macro definitions.
471# python main version
c853f847 472%py_ver %(echo `python -c "import sys; print sys.version[:3]"`)
25043cd4
AF
473
474# directories
c853f847 475%py_prefix %(echo `python -c "import sys; print sys.prefix"`)
aadb0079 476%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 477%py_scriptdir %{py_prefix}/share/python%{py_ver}
c853f847 478%py_incdir /usr/include/python%{py_ver}
ef7ec0a8
JK
479%py_sitedir %{py_libdir}/site-packages
480%py_sitescriptdir %{py_scriptdir}/site-packages
c853f847 481%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
482
483# pure python modules compilation
c853f847 484%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 485
c853f847 486%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
487
488# Software written in Python language require Python with main version
e63cd81d 489%pyrequires_eq() Requires: %1
25043cd4 490
f12c2314
AF
491
492# Hardlink binary identical .pyc and .pyo files
493# (idea by glen <at> pld-linux <dot> org)
494%__spec_install_post_py_hardlink {\
d56b7e24 495%{!?no_install_post_py_hardlink: \
f12c2314
AF
496[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
497 b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
498 if cmp -s "$a" "$b"; then \
499 ln -f "$a" "$b"; \
500 fi; \
501done \
502} }
503
9227b3f9 504# remove python sources, so that check-files won't complain
f12c2314
AF
505# (idea by glen <at> pld-linux <dot> org)
506%py_postclean() \
507for d in %{py_sitescriptdir} %{py_sitedir}; do \
508 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -exec rm {} \; ;\
509done \
510%{nil}
511
0fc5cff8 512# depmod macro
513%depmod() { \
f6148427 514umask 022; \
0fc5cff8 515if [ -e /boot/System.map-%1 ]; then \
516 /sbin/depmod -a -F /boot/System.map-%1 %1; \
517else \
518 if [ -e /boot/System.map ]; then \
519 /sbin/depmod -a -F /boot/System.map %1; \
520 else \
521 /sbin/depmod -a %1; \
522 fi \
523fi; \
524}
525
2afc6e64 526# XMMS specific macros
2d372986
JB
527%xmms_prefix %(xmms-config --prefix)
528%xmms_exec_prefix %(xmms-config --exec-prefix)
529%xmms_version %(xmms-config --version)
530%xmms_datadir %(xmms-config --data-dir)
531%xmms_plugindir %(xmms-config --plugin-dir)
532%xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir)
533%xmms_input_plugindir %(xmms-config --input-plugin-dir)
534%xmms_output_plugindir %(xmms-config --output-plugin-dir)
535%xmms_effect_plugindir %(xmms-config --effect-plugin-dir)
536%xmms_general_plugindir %(xmms-config --general-plugin-dir)
2afc6e64 537
d1537778
PS
538%_target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
539
f031b1b0 540%x8664 x86_64 amd64 ia32e
848c0d68 541
542# user/group checking macros
543#
544# Usage:
545# %userremove myuser
546#
547%userremove /usr/lib/rpm/user_group.sh user del
548%groupremove /usr/lib/rpm/user_group.sh group del
549#
550# Usage:
551# if %usertestrm myuser; then
552# /usr/sbin/userdel -r myuser
553# Note:
554# use these macros only if you need to call userdel/groupdel with
555# a non-standard option or take an extra action; otherwise use the
556# %userremove/%groupremove macros
557#
558%usertestrm /usr/lib/rpm/user_group.sh user testrm
559%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
560# user group membership management macros
561#
562# Usage:
563# %addusertogroup myuser agroup
564#
565%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
72fcfcb3 566
567# banner support (useful in {pre,post}{,un} and triggers)
568#
569# Usage:
aa41c920 570# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 571# the banner text, the banner text
aa41c920
ER
572# the banner text, and following line
573#EOF
574# You can use any form of here-document, <<'EOF' <<-EOT will do.
575# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
576#
72fcfcb3 577# -a - append to the banner
a8b9562a 578# -e - send to stderr instead of stdout
628754cb 579# -n - no show banner (overrides -t)
580# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
aa41c920 581%banner(aent:) \
1b334fe4 582RPM_SCRIPTVERBOSITY=5 \
583[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
584if [ -x /usr/bin/banner.sh ]; then \
aa41c920 585 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 586else \
a8b9562a 587 CMD="cat%{-e: >&2}" \
1b334fe4 588fi \
aa41c920 589$CMD %2%{?3: %3} \
72fcfcb3 590%nil
628754cb 591
90627280
ER
592# useradd/groupadd macros written by glen@pld-linux.org.
593# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
594#
595# Usage:
596# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
597# [-g initial_group] [-G group[,...]] login
598#
599# -u uid. REQUIRED
600# -g gid/group. REQUIRED
601# -s defaults to /bin/false
602# -d defaults to /usr/share/empty
603# -c No default
604# -r is accepted but ignored (it's always set)
605# rpm specific flags
606# -P package name. defaults to %{name}
607#
90627280 608%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
609%{!-u:%{error:useradd: Required argument -u missing}} \
610%{!-g:%{error:useradd: Required argument -g missing}} \
611%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
612if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
613 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
614 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
615 exit 1 \
616 fi \
617else \
618 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
619 /usr/sbin/useradd \\\
620 -u %{-u*} \\\
621 -r \\\
622 -d %{-d*}%{!-d:/usr/share/empty} \\\
623 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 624 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
625 -g %{-g*} \\\
626 %{-M} \\\
627 %{-G:-G %{-G*}} \\\
840e7b00 628 %{expand:%{%{#}}} 1>&2 \
90627280
ER
629fi;
630
90627280
ER
631# Usage:
632# %groupadd [-P package] [-g gid] group
633#
634# -g gid. REQUIRED
635#
636# Sample:
637# %groupadd -P %{name}-base -g %{gid} %{name}
638
639%groupadd(g:P:rfo) \
9ba02ba9
ER
640%{!-g:%{error:groupadd: Required argument -g missing}} \
641%{!?1:%{error:groupadd: Required parameter group missing}} \
90627280
ER
642if [ -n "`/usr/bin/getgid %{1}`" ]; then \
643 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
644 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
645 exit 1 \
646 fi \
647else \
648 echo "Adding group %{1} GID=%{-g*}." \
840e7b00 649 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 \
90627280 650fi;
This page took 0.192421 seconds and 4 git commands to generate.